#!/usr/bin/env zsh

(( ${#} < 1 )) && { echo 'Device name is required'; exit 1 }

local devdir="${HOME}/nextcloud/KeePassXC/${1}"

if ! [ -d "${devdir}" ]; then
    mkdir "${devdir}" || exit 1
fi

# Remove files older than 30 days (files modified more than 30 days ago)
find "${devdir}" -depth -mtime +30 -delete

local datetime="$(date +'d%d-%m-%Y_t%H-%M-%S')"
local filename="keepassxc-db-backup-${datetime}.tar.gz"
tar -caf \
    "${devdir}/${filename}" \
    "${HOME}/.keepassxc"
